Public Class Form1
    Private m_NumValues As Integer
    Private m_Used() As Integer
    Private m_CurrentSolution() As Integer

    Private Sub btnGo_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnGo.Click
        lstResults.Items.Clear()
        Application.DoEvents()

        m_NumValues = Val(txtNumItems.Text)
        ReDim m_Used(m_NumValues)
        ReDim m_CurrentSolution(m_NumValues)
        EnumerateValues(1)

        txtCombinations.Text = Format$(Factorial(m_NumValues))
    End Sub

    Private Sub EnumerateValues(ByVal index As Integer)
        ' See if there are any values left to try.
        If index > m_NumValues Then
            ' All values are Used.
            ' Get a string for the current solution.
            Dim result As String = ""
            For i As Integer = 1 To m_NumValues
                result &= Format$(m_CurrentSolution(i)) & " "
            Next i

            ' Add the current solution to the list.
            lstResults.Items.Add(result)
            Exit Sub
        End If

        ' Examine each value.
        For i As Integer = 1 To m_NumValues
            ' See if this value has been used yet.
            If Not m_Used(i) Then
                ' It is unused. Try using it.
                m_Used(i) = True
                m_CurrentSolution(index) = i

                EnumerateValues(index + 1)

                m_Used(i) = False
            End If
        Next i
    End Sub

    Private Function Factorial(ByVal num As Long) As Long
        Dim result As Long = 1
        For i As Integer = 2 To num
            result *= i
        Next i
        Return result
    End Function

End Class
